<%@ page contentType="text/html;charset=UTF-8"%>
<link rel="stylesheet" type="text/css" href="${ctxStatic}/jBox/Source/jBox.css">
<script type="text/javascript" src="${ctxStatic}/jBox/Source/jBox.min.js"></script>

<div id="trial-detail-content" class="container-fluid" style="display:none">
<div class="row-fluid">
    <div id="trial-left-div" class="span7">
        <canvas id="trial-canvas" style="width:100%"></canvas>
    </div>
    <div id="trial-right-div" class="span5">
        <table id="contentTable" class="table table-striped table-bordered table-condensed">
            <thead>
                <tr>
                    <th>评卷员</th>
                    <th>姓名</th>
                    <th>给分</th>
                    <th>时间</th>
                </tr>
            </thead>
            <tbody id="trial-history">
            </tbody>
        </table>
    </div>
</div>
</div>

<script type="text/javascript">
var trailDetailModal = new jBox('Modal');

$(document).ready(function() {
    //$('#trial-left-div').height($(window).height()*0.83);
});

function initTrialDetailPopover(title, libraryId) {
	initTrialDetailContent(libraryId); 
	trailDetailModal.setWidth($(window).width()*0.9);
	trailDetailModal.setHeight($(window).height()*0.85);
	trailDetailModal.setTitle(title);
	trailDetailModal.open();
}

function initTrialDetailContent(libraryId){
	$('#trial-history').empty();
	$.ajax({
        type:"GET",
        url:'${ctx}/admin/exam/trial/detail?libraryId='+libraryId,  
        dataType:"json",
        success:function(data){
	        if(data.success==true) {
	            for (var i = 0; i < data.historyList.length; i++) {
	                var history = data.historyList[i];
	                $('#trial-history').append('<tr><td>'+history.loginName+'</td><td>'+history.name+'</td><td>'+history.score+'</td><td>'+history.time+'</td></tr>');
	            }
	            var canvas = document.getElementById('trial-canvas');
	            var ctx = canvas.getContext('2d');
	            buildImages(data.imageServer, data.urls, data.pictureConfig, canvas, ctx, function(){
	                trailDetailModal.setContent($('#trial-detail-content'));
	            });
	        }else {
	            trailDetailModal.setTitle('加载失败')
	        }
        }
    });
}

function buildImages(imageServer, picUrls, config, canvas, ctx, callback) {
    var indexSet = {};
    for(var i=0;i<config.length;i++){
        indexSet[config[i].i-1] = true;
    }
    //调用图片预加载函数，实现回调函数
    var imageObjects = [];
    loadImages(imageObjects, imageServer, indexSet, picUrls, 0, function(images) {
        var maxWidth = 0;
        var totalHeight = 0;
        for (var i = 0; i < config.length; i++) {
            //计算最大宽度与合计高度
            if(config[i].w<=0){
                config[i].w=images[config[i].i-1].width;
            }
            if(config[i].h<=0){
                config[i].h=images[config[i].i-1].height;
            }
            maxWidth = Math.max(maxWidth, config[i].w);
            totalHeight += config[i].h;
        }
        if (maxWidth > 0 && totalHeight > 0) {
            //设置画布大小及背景颜色
            canvas.width = maxWidth;
            canvas.height = totalHeight;
            //ctx.fillStyle = "#FFFFFF";
            //ctx.fillRect(0, 0, maxWidth, totalHeight);
            //绘画到画布
            var height = 0;
            for (var i = 0; i < config.length; i++) {
                var image = images[config[i].i-1];
                ctx.drawImage(image, config[i].x, config[i].y, config[i].w, config[i].h, 0, height, config[i].w, config[i].h);
                height += config[i].h;
            }
        }else {
            canvas.width=1;
            canvas.height=1;
        }
        callback();
    });
}

function loadImages(images, imageServer, indexSet, urls, number, callback) {
    if (urls != undefined && number < urls.length) {
        if(indexSet[number]==true) {
            var img = new Image();
            img.onload = function() {
                images.push(img);
                loadImages(images, imageServer, indexSet, urls, number + 1, callback);
            }
            img.crossOrigin = '';
            img.src = imageServer + urls[number] + '?' + new Date().getTime();
        }else {
            images.push({});
            loadImages(images, imageServer, indexSet, urls, number + 1, callback);
        }
    } else {
        callback.call(this, images);
    }
}
</script>



